// Start broker

// Listen for will message on a different client
// $ mosquitto_sub -h localhost -p 1883 -t 'will-topic' -d

// Run this file using node
// $ node test.js

// Notice the second will message is usually not published
// Also notice that sometimes the broker crashes with 139 exit status

// You may need to run this script a few times to reproduce… Sorry.

const mqtt = require('mqtt');

function test() {
    const options = {
        will: {
            topic: 'will-topic',
            payload: 'hello',
            properties: {
                willDelayInterval: 30
            }
        },
        protocolVersion: 5,
        clientId: 'test',
        properties: {
            sessionExpiryInterval: 3
        }
    }

    const client  = mqtt.connect('mqtt://localhost:1883', options);

    client.on('connect', function () {
        client.end(false, {
            reasonCode: 4
        }, () => {
            setTimeout(() => {
                test2();
            }, 10000)
        });
    })
}


function test2() {
    const options = {
        will: {
            topic: 'will-topic',
            payload: 'hello',
            properties: {
                willDelayInterval: 3
            }
        },
        protocolVersion: 5,
        clientId: 'test',
        properties: {
            sessionExpiryInterval: 30
        }
    }

    const client  = mqtt.connect('mqtt://localhost:1883', options);

    client.on('connect', function () {
        client.end(false, {
            reasonCode: 4
        }, () => {
            console.log('All Done!')
        });
    })
}

test();